/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import java.util.logging.Logger;
import javax.sip.RequestEvent;
import javax.sip.header.AllowEventsHeader;
import javax.sip.header.AllowHeader;
import javax.sip.header.CSeqHeader;
import javax.sip.header.CallIdHeader;
import javax.sip.header.ContactHeader;
import javax.sip.header.FromHeader;
import javax.sip.header.HeaderFactory;
import javax.sip.header.ToHeader;
import javax.sip.header.ViaHeader;
import javax.sip.message.MessageFactory;
import javax.sip.message.Response;
import logger.OhmLogger;

/**
 *
 * @author Jan
 */
public class SIP200Ok
{
  private Response response;
  private static final Logger lg200Ok = OhmLogger.getLogger();
  public SIP200Ok(MessageFactory messageFactory, RequestEvent requestEvent,
                  ContactHeader contactHeader, HeaderFactory headerFactory)
  {
    try
    {
      Response response = messageFactory.createResponse(200, requestEvent.getRequest());
      response.addHeader((ViaHeader) requestEvent.getRequest().getHeader("Via"));
      response.addHeader((FromHeader) requestEvent.getRequest().getHeader("From"));
      response.addHeader((ToHeader) requestEvent.getRequest().getHeader("To"));
      response.addHeader((CallIdHeader) requestEvent.getRequest().getHeader("Call-ID"));
      response.addHeader((CSeqHeader) requestEvent.getRequest().getHeader("Cseq"));
      response.addHeader(contactHeader);
      AllowHeader allow = headerFactory.createAllowHeader("NOTIFY,INVITE,ACK,CANCEL,BYE,REFER,INFO,OPTIONS,MESSAGE");
      AllowEventsHeader allowevents = headerFactory.createAllowEventsHeader("talk,hold,refer,call-info");
      response.addHeader((CallIdHeader) requestEvent.getRequest().getHeader("Call-ID"));
      response.addHeader(allow);
      response.addHeader(allowevents);
      lg200Ok.info("200Ok Header erfolgreich erstellt");
    }
    catch (Exception ex)
    {
      lg200Ok.getLogger(SIPmodel.class.getName()).log(Level.SEVERE, null, ex);
    }
  }

  /**
   * @return the response
   */
  public Response getResponse()
  {
    return response;
  }
}
